<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/31/2003 *
 * ===============                              Last change: 07/02/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : admin.php                                        *
 * -------------------------------------------------------------------- *
 * Short description : Administration module                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Administrationsmodul                             *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Login is default
if ((empty($GLOBALS['action'])) && ($check == "admin_only")) {
	// Redirect to right URL
	LOAD_URL("modules.php?module=admin&amp;action=login");
} // END - if

// Load include file
require_once(PATH."inc/modules/admin/admin-inc.php");

// Fix "deleted" cookies in PHP4 (PHP5 does remove them, PHP4 sets them to deleted!)
FIX_DELETED_COOKIES(array('admin_login', 'admin_md5', 'admin_last', 'admin_to'));

if (!isBooleanConstantAndTrue('admin_registered')) {
	// Admin is not registered so we have to inform the user
	if ((isset($_POST['ok'])) && ((empty($_POST['login'])) || (empty($_POST['pass'])) || (strlen($_POST['pass']) < 4))) $_POST['ok'] = "***";
	if ((isset($_POST['ok'])) && ($_POST['ok'] != "***")) {
		// Hash the password with the old function because we are here in install mode
		$hashedPass = md5($_POST['pass']);

		// Kill maybe existing session variables
		set_session('admin_login'	, "");
		set_session('admin_md5'		, "");
		set_session('admin_last'	, "");
		set_session('admin_to'		, "");

		// Do registration
		$ret = REGISTER_ADMIN($_POST['login'], $hashedPass);
		switch ($ret)
		{
		case "done":
			admin_WriteData(PATH."inc/config.php", "ADMIN-SETUP", "define('admin_registered', ", ");", "true", 0);
			if (!_FATAL) {
				// Registering is done
				LOAD_URL(URL."/modules.php?module=admin&amp;action=login&register=done");
			} else {
				$ret = ADMIN_CANNOT_COMPLETE;
			}
			break;

		case "failed":
			$ret = ADMIN_REGISTER_FAILED;
			break;

		case "already":
		default:
			if ($ret == "already") {
				// Admin does already exists!
				$ret = ADMIN_LOGIN_ALREADY_REG;
			} else {
				// Any other kind
				$ret = "done";
			}

			// Admin still not registered?
			if (!isBooleanConstantAndTrue('admin_registered')) {
				// Write to config that registration is done
				admin_WriteData(PATH."inc/config.php", "ADMIN-SETUP", "define('admin_registered', ", ");", "true", 0);

				// Load URL for login
				$URL = URL."/modules.php?module=admin&amp;action=login";
				LOAD_URL($URL);
			} // END - if
			break;
		}
	}

	// Whas that action okay?
	if ($ret != "done") {
		// Fixes another "Notice"
		if (!empty($_POST['login'])) {
			define('__LOGIN_VALUE', $_POST['login']);
		} else {
			define('__LOGIN_VALUE', "");
		}

		// Yet-another "Notice" fix
		if ((!empty($_POST['ok'])) && ($_POST['ok'] == "***")) {
			// No login entered?
			if (empty($_POST['login'])) $MSG1 = ADMIN_NO_LOGIN;

			// An error comes back from registration?
			if (!empty($ret)) $MSG1 = $ret;

			// No password entered?
			if (empty($_POST['pass'])) $MSG2 = ADMIN_NO_PASS;

			// Or password too short?
			if (strlen($_POST['pass']) < 4) $MSG2 = ADMIN_SHORT_PASS;

			// Output error messages
			define('__MSG_LOGIN', LOAD_TEMPLATE("admin_login_msg", true, $MSG1));
			define('__MSG_PASS',  LOAD_TEMPLATE("admin_login_msg", true, $MSG2));

			// Reset variables
  			$MSG1 = ""; $MSG2 = "";
  		} else {
			// Reset values to nothing
			define('__MSG_LOGIN', "");
			define('__MSG_PASS' , "");
		}

		// Load register template
		LOAD_TEMPLATE("admin_reg_form");
	}
} elseif (isset($_GET['reset_pass'])) {
	// Is the form submitted?
	if ((isset($_POST['send_link'])) && (!empty($_POST['email']))) {
		// Try to send the link out
		$OUT = ADMIN_SEND_PASSWORD_RESET_LINK($_POST['email']);

		// Output result
		LOAD_TEMPLATE("admin_settings_saved", false, $OUT);
	} elseif (!empty($_GET['hash'])) {
		// Output form for hash validation
		LOAD_TEMPLATE("admin_validate_reset_hash_form", false, $_GET['hash']);
	} elseif ((isset($_POST['validate_hash'])) && (!empty($_POST['login'])) && (!empty($_POST['hash']))) {
		// Validate the login data and hash
		$valid = ADMIN_VALIDATE_RESET_LINK_HASH_LOGIN($_POST['hash'], $_POST['login']);

		// Valid?
		if ($valid) {
			// Prepare content first
			$content = array(
				'hash'  => SQL_ESCAPE($_POST['hash']),
				'login' => SQL_ESCAPE($_POST['login'])
			);

			// Validation okay so display form for final password change
			LOAD_TEMPLATE("admin_reset_password_form", false, $content);
		} else {
			// Cannot validate the login data and hash
			LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_VALIDATION_RESET_LOGIN_HASH_FAILED);
		}
	} elseif ((isset($_POST['reset_pass'])) && (!empty($_POST['hash'])) && (!empty($_POST['login'])) && (!empty($_POST['pass1'])) && ($_POST['pass1'] == $_POST['pass2'])) {
		// Okay, we shall the admin password here. So first revalidate the hash
		if (ADMIN_VALIDATE_RESET_LINK_HASH_LOGIN($_POST['hash'], $_POST['login'])) {
			// Set the password now
			$OUT = ADMIN_RESET_PASSWORD($_POST['login'], $_POST['pass1']);

			// Output result
			LOAD_TEMPLATE("admin_reset_pass_done", false, $OUT);
		} else {
			// Validation failed
			LOAD_TEMPLATE("admin_settings_saved", false, ADMIN_VALIDATION_RESET_LOGIN_HASH_FAILED2);
		}
	} else {
		// Output reset password form
		LOAD_TEMPLATE("admin_send_reset_link");
	}
} elseif ((!isSessionVariableSet('admin_login')) || (!isSessionVariableSet('admin_md5')) || (!isSessionVariableSet('admin_last')) || (!isSessionVariableSet('admin_to')) || ((get_session('admin_last') + bigintval(get_session('admin_to')) * 3600 * 24) < time())) {
	// At leat one administrator account was created
	if ((isSessionVariableSet('admin_login')) && (isSessionVariableSet('admin_md5')) && (isSessionVariableSet('admin_last')) && (isSessionVariableSet('admin_to'))) {
		// Timeout for last login, we have to logout first!
		$URL = URL."/modules.php?module=admin&amp;action=login&amp;logout=1";
		LOAD_URL($URL);
	}
	if (!empty($_GET['register'])) {
		// Registration of first admin is done
		if ($_GET['register'] == "done") OUTPUT_HTML("<STRONG class=\"admin\">".ADMIN_REGISTER_DONE."</STRONG>");
	} // END - if

	// Check if the admin has submitted data or not
	$ret = "";
	if ((isset($_POST['ok'])) && ((empty($_POST['login'])) || (empty($_POST['pass'])) || (strlen($_POST['pass']) < 4))) $_POST['ok'] = "***";
	if ((isset($_POST['ok'])) && ($_POST['ok'] != "***")) {
		// All required data was entered so we check his account
		$ret = CHECK_ADMIN_LOGIN($_POST['login'], $_POST['pass']);

		// Which status do we have?
		switch ($ret)
		{
		case "done": // Admin and password are okay, so we log in now
			// Construct URL and redirect
			$URL = URL."/modules.php?module=admin&amp;";

			// Rewrite overview module
			if ($GLOBALS['what'] == "overview") {
				$GLOBALS['action'] = GET_ACTION($GLOBALS['module'], $GLOBALS['what']);
			}

			// Add data to URL
			if (!empty($GLOBALS['what'])) $URL .= "what=".$GLOBALS['what'];
			 elseif (!empty($GLOBALS['action'])) $URL .= "action=".$GLOBALS['action'];
			 elseif (!empty($_GET['area'])) $URL .= "area=".$_GET['area'];

			// Load URL
			LOAD_URL($URL);
			break;

		case "404": // Administrator login not found
			$_POST['ok'] = $ret;
			$ret = ADMIN_NOT_FOUND;
			DESTROY_ADMIN_SESSION();
			break;

		case "pass": // Wrong password
			$_POST['ok'] = $ret;
			$ret = WRONG_PASS." [<A href=\"".URL."/modules.php?module=admin&amp;reset_pass=1\">".ADMIN_RESET_PASS."</A>]\n";
			DESTROY_ADMIN_SESSION();
			break;
		}
	}
	if ($ret != "done") {
		if (!empty($_POST['login'])) {
			define('__LOGIN_VALUE', $_POST['login']);
		} else {
			define('__LOGIN_VALUE', "");
		}

		if (isset($_POST['ok'])) {
			// Set messages to zero

			$MSG1 = ""; $MSG2 = "";
			// No login entered?
			if (empty($_POST['login'])) $MSG1 = ADMIN_NO_LOGIN;

			// An error comes back from login?
			if ((!empty($ret)) && ($_POST['ok'] == "404")) $MSG1 = $ret;

			// No password entered?
			if (empty($_POST['pass'])) $MSG2 = ADMIN_NO_PASS;

			// Or password too short?
			if (strlen($_POST['pass']) < 4) $MSG2 = ADMIN_SHORT_PASS;

			// An error comes back from login?
			if ((!empty($ret)) && ($_POST['ok'] == "pass")) $MSG2 = $ret;

			// Load message template
			define('__MSG_LOGIN', LOAD_TEMPLATE("admin_login_msg", true, $MSG1));
			define('__MSG_PASS' , LOAD_TEMPLATE("admin_login_msg", true, $MSG2));

			// Reset variables
  			$MSG1 = ""; $MSG2 = "";
  		} else {
			// Set constants to empty for hiding them
			define('__MSG_LOGIN', "");
			define('__MSG_PASS' , "");
		}

		// Load login form
		if (!empty($GLOBALS['what'])) {
			// Restore old what value
			$content = array('target' => "what", 'value' => $GLOBALS['what']);
		} elseif (!empty($GLOBALS['action'])) {
			if ($GLOBALS['action'] != "logout") {
				// Restore old action value
				$content = array('target' => "action", 'value' => $GLOBALS['action']);
			} else {
				// Set default values
				$content = array('target' => "action", 'value' => "login");
			}
		} elseif (!empty($_GET['area'])) {
			// Restore old area value
			$content = array('target' => "area", 'value' => $_GET['area']);
		} else {
			// Set default values
			$content = array('target' => "action", 'value' => "login");
		}

		// Load login form template
		LOAD_TEMPLATE("admin_login_form", false, $content);
	}
} elseif (isset($_GET['logout'])) {
	// Only try to remove cookies
	if (DESTROY_ADMIN_SESSION()) {
		// Load logout template
		if (isset($_GET['register'])) {
			// Secure input
			$register = SQL_ESCAPE($_GET['register']);

			// Special logout redirect for installation of given extension
			LOAD_TEMPLATE(sprintf("admin_logout_%s_install", $register));
		} elseif (isset($_GET['remove'])) {
			// Secure input
			$remove = SQL_ESCAPE($_GET['remove']);

			// Special logout redirect for removal of given extension
			LOAD_TEMPLATE(sprintf("admin_logout_%s_remove", $remove));
		} else {
			// Logged out normally
			LOAD_TEMPLATE("admin_logout");
		}
	} else {
		// Something went wrong here...
		OUTPUT_HTML("<STRONG class=\"admin_fatal\">".ADMIN_LOGOUT_FAILED."</STRONG>");

		// Add fatal message
		ADD_FATAL(CANNOT_UNREG_SESS);
	}
} else {
	// Maybe an Admin want's to login?
	$ret = CHECK_ADMIN_COOKIES(get_session('admin_login'), get_session('admin_md5'));
	switch ($ret)
	{
	case "done":
		// Cookie-Data accepted
		if ((set_session("admin_md5", get_session('admin_md5'))) && (set_session("admin_login", get_session('admin_login'))) && (set_session("admin_last", time())) && (set_session("admin_to", bigintval(get_session('admin_to'))))) {
			// Ok, Cookie-Update done
			if ((EXT_IS_ACTIVE("admins")) && (GET_EXT_VERSION("admins") > "0.2")) {
				// Check if action GET variable was set
				$act = SQL_ESCAPE($GLOBALS['action']);
				if (!empty($GLOBALS['what'])) {
					// Get action value by what-value
					$act = GET_ACTION("admin", $GLOBALS['what']);
				}

				// Check for access control line of current menu entry
				define('__ACL_ALLOW', ADMINS_CHECK_ACL($act, $GLOBALS['what']));
			} else {
				// Extension not installed so it's always allowed to access everywhere!
				define('__ACL_ALLOW', true);
			}

			// When type of admin menu is not set fallback to old menu system
			if (empty($_CONFIG['admin_menu'])) $_CONFIG['admin_menu'] = "OLD";

			// Check for version and switch between old menu system and new "intelligent menu system"
			if ((ADMIN_CHECK_MENU_MODE() == "NEW") && (FILE_READABLE(PATH."inc/modules/admin/lasys-inc.php"))) {
				// Default area is the entrance, of course
				$area = "entrance";

				// Check for similar URL variable
				if (!empty($_GET['area'])) $area = SQL_ESCAPE($_GET['area']);

				// Load "logical-area menu-system" file
				require_once(PATH."inc/modules/admin/lasys-inc.php");

				// Create new-style menu system will "logical areas"
				ADMIN_LOGICAL_AREA_SYSTEM($area, $act, $GLOBALS['what']);
			} else {
				// This little call constructs the whole default old and lacky menu system
				// on left side
				ADMIN_DO_ACTION($GLOBALS['what']);
			}
		} else {
			// Login failed (cookies enabled?)
			OUTPUT_HTML("<STRONG class=\"admin_fatal\">".ADMIN_LOGIN_FAILED."</STRONG>");
			ADD_FATAL(CANNOT_RE_REGISTER_SESS);
		}
		break;

	case "404": // Administrator login not found
		$_POST['ok'] = $ret;
		DESTROY_ADMIN_SESSION();
		ADD_FATAL(ADMIN_NOT_FOUND);
		break;

	case "pass": // Wrong password
		$_POST['ok'] = $ret;
		DESTROY_ADMIN_SESSION();
		ADD_FATAL(WRONG_PASS);
		break;
	}
}

//
?>
