<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 12/12/2008 *
 * ===============                              Last change: 12/12/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : pool-bonus.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Sends queued bonus mails from the pool           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sendet freigegebene Bonus-Mails aus dem Pool     *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Don't run on daily reset
if (defined('__DAILY_RESET')) {
	// Skip here
	return false;
} elseif (!EXT_IS_ACTIVE("bonus")) {
	// Abort if extension bonus is not active
	return false;
}

// Only send bonus mail when bonus extension is active and maximum send-mails is not reached
if ($cnt < $_CONFIG['max_send']) {
	// Do we need to send out bonus mails?
	if (EXT_IS_ACTIVE("html_mail")) {
		//                                 0     1       2        3        4      5       6          7       8      9         10         11
		$result_bonus = SQL_QUERY("SELECT id, subject, text, receivers, points, time, data_type, timestamp, url, cat_id, target_send, html_msg FROM "._MYSQL_PREFIX."_bonus WHERE data_type='NEW' ORDER BY timestamp DESC", __FILE__, __LINE__);
	} else {
		//                                 0     1       2        3        4      5       6          7       8      9         10
		$result_bonus = SQL_QUERY("SELECT id, subject, text, receivers, points, time, data_type, timestamp, url, cat_id, target_send FROM "._MYSQL_PREFIX."_bonus WHERE data_type='NEW' ORDER BY timestamp DESC", __FILE__, __LINE__);
	}

	if (SQL_NUMROWS($result_bonus) > 0) {
		// Send these mails away...
		$cnt2 = "";
		while ($DATA = SQL_FETCHARRAY($result_bonus)) {
			// Compile URL
			$DATA['url'] = COMPILE_CODE($DATA['url']);

			// Message is active in queue
			$result_queue = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_bonus SET data_type='QUEUE' WHERE id=%s LIMIT 1",
				array(bigintval($DATA['id'])), __FILE__, __LINE__);

			// "Explode" all receivers into an array
			if (ereg(";", $DATA['receivers'])) {
				// There's more than one receiver in the list...
				$RECEIVERS = explode(";", $DATA['receivers']);
			} elseif (!empty($DATA['points'])) {
				// Only one user left
				$RECEIVERS = array($DATA['receivers']);
			} else {
				// No users left
				$RECEIVERS = array("0");
			}
			$dummy = $RECEIVERS;

			// Now, if we are good little boys and girls Santa left us some user-ids.
			// We can now send mails to them...
			foreach ($RECEIVERS as $key => $uid) {
				// Load personal data
				//* DEBUG: */ echo "*L:".__LINE__."/".$uid."*<br />";
				$result_user = SQL_QUERY_ESC("SELECT surname, family, email FROM "._MYSQL_PREFIX."_user_data WHERE userid=%s LIMIT 1",
				 array(bigintval($uid)), __FILE__, __LINE__);

				// Is his data available?
				if (SQL_NUMROWS($result_user) == 1)
				{
					// The final receiver does exists so we can continue...
					list($sname, $fname, $email) = SQL_FETCHROW($result_user);
					//* DEBUG: */ echo "OK!/L:".__LINE__."<br />";

					// Mark this user as "spammed" ;-) And place a line for him...
					if (REMOVE_RECEIVER($dummy, $key, $uid, $DATA['id'], $DATA['id'], true) == "done")
					{
						// Replace text variables
						foreach ($REPLACER as $key => $value) {
							if (isset($DATA[$key])) $DATA['text'] = str_replace($value, $DATA[$key], $DATA['text']);
						} // END - foreach

						// Prepare content
						$content = array(
							'id'       => $DATA['id'],
							'url'      => $DATA['url'],
							'time'     => CREATE_FANCY_TIME($DATA['time']),
							'points'   => TRANSLATE_COMMA($DATA['points']),
							'category' => GET_CATEGORY($DATA['cat_id']),
							'text'     => $DATA['text']
						);

						// Prepare the mail
						$msg = LOAD_EMAIL_TEMPLATE("bonus-mail", $content, $uid);

						// Send mail away
						if (isset($DATA['html_msg'])) {
							// Send HTML?
							SEND_EMAIL($email, $DATA['subject'], $msg, $DATA['html_msg']);
						} else {
							// No HTML mail!
							SEND_EMAIL($email, $DATA['subject'], $msg);
						}

						// Count one up and remove entry from dummy array
						$cnt++; unset($dummy[$key]);

						if (GET_EXT_VERSION("user") >= "0.1.4")
						{
							// Update mails received for receiver
							$result = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_user_data SET emails_received=emails_received+1 WHERE userid=%s LIMIT 1",
							 array(bigintval($uid)), __FILE__, __LINE__);
						}

						// Do we have send maximum mails?
						if (($cnt >= $_CONFIG['max_send']) || (SELECTION_COUNT($dummy) == 0))
						{
							// Yes, we have
							//* DEBUG: */ echo "*EXIT/L:".__LINE__."<br />";
							break;
						}
					}
				}

				// Free some memory
				SQL_FREERESULT($result_user);
			}

			// Update mediadata if version is 0.0.4 or higher
			if (GET_EXT_VERSION("mediadata") >= "0.0.4")
			{
				// Update entry (or add missing
				$P = $cnt;
				if (!empty($cnt2) && empty($cnt)) $P = $cnt2;
				//* DEBUG: */ echo "+MEDIA/L:".__LINE__."/".$P."+<br />";
				MEDIA_UPDATE_ENTRY(array("total_send", "bonus_send"), "add", $P);
			}

			// Close sending system
			//* DEBUG: */ echo "-L:".__LINE__."/".SELECTION_COUNT($dummy)."-<br />";
			if (SELECTION_COUNT($dummy) == 0)
			{
				// Queue reached!
				$result_done = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_bonus SET data_type='SEND', target_send='0', receivers='' WHERE id=%s LIMIT 1",
				 array(bigintval($DATA['id'])), __FILE__, __LINE__);
				//* DEBUG: */ echo "*L:".__LINE__."*<br />";

				// Update mediadata if version is 0.0.4 or higher
				if (GET_EXT_VERSION("mediadata") >= "0.0.4")
				{
					// Update entry (or add missing)
					//* DEBUG: */ echo "*MEDIA/L:".__LINE__."*<br />";
					MEDIA_UPDATE_ENTRY(array("total_orders", "bonus_orders"), "add", 1);
				}
			}
			 elseif ($cnt >= $_CONFIG['max_send'])
			{
				// Update bonus pool
				$result_done = SQL_QUERY_ESC("UPDATE "._MYSQL_PREFIX."_bonus SET data_type='NEW', target_send=%s, receivers='%s' WHERE id=%s LIMIT 1",
				 array(SELECTION_COUNT($dummy), implode(";", $dummy), bigintval($DATA['id'])), __FILE__, __LINE__);
				//* DEBUG: */ echo "*L:".__LINE__."<PRE>";
				//* DEBUG: */ print_r($dummy);
				//* DEBUG: */ echo "</PRE>\n!!!<br />";
				break;
			}
		}
	}

	// Free memory
	SQL_FREERESULT($result_bonus);
}

// Remove message (IMPORTANT!)
unset($msg);

//
?>
